config/routes.rb
Rails.application.routes.draw do

  namespace :admin do
    resources :bookings
  end
	root to: 'home#index'
	resources :bookings
  get '/donwload_invoice', controller: 'bookings', action: 'donwload_invoice'
	get '/admin/reports', controller: 'admin/bookings', action: 'reports', as: :admin_reports
  # devise_for :users
  Rails.application.routes.draw do
    devise_for :users, controllers: {
      sessions: 'users/sessions'
    }
  end

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/booked_seat.rb
class BookedSeat < ApplicationRecord
	belongs_to :booking
	belongs_to :seat
end

app/models/booking.rb
class Booking < ApplicationRecord
	belongs_to :show
	belongs_to :movie
	belongs_to :customer , :class_name => 'User'
	has_many :booked_seats

	def total_amount
		self.booked_seats.map{|booked_seat|booked_seat.seat.row.screen.price}.sum
	end
	
end

app/models/movie.rb
class Movie < ApplicationRecord
	serialize :star_casts, Hash
	mount_uploader :banner, BannerUploader

	has_many :shows
end

app/models/row.rb
class Row < ApplicationRecord
	belongs_to :screen
	has_many :seats
end

app/models/screen.rb
class Screen < ApplicationRecord
	has_many :rows

	belongs_to :theatre
	has_many :rows
end

app/models/seat.rb
class Seat < ApplicationRecord
	belongs_to :row
	belongs_to :seat_type
end

app/models/seat_type.rb
class SeatType < ApplicationRecord
	belongs_to :theatre
	has_many :seats
end

app/models/show.rb
class Show < ApplicationRecord
	belongs_to :movie
	belongs_to :time_slot
end

app/models/theatre.rb
class Theatre < ApplicationRecord
	has_many :seat_types
	has_many :time_slots
	has_many :screens
end

app/models/time_slot.rb
class TimeSlot < ApplicationRecord
	belongs_to :theatre
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
  has_many :bookings, foreign_key: :customer_id

  after_create :set_role

  def set_role
    self.update_column('role', 'Customer') if self.role != 'Admin'
  end

   def admin?
   	 role == 'Admin'
   end

   def customer?
   		role == 'Customer'
   end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
	protected  
  def after_sign_in_path_for(resource)
  	if current_user.admin?
		  admin_bookings_path
		 else
		  root_path
		 end
  end
end

app/controllers/bookings_controller.rb
class BookingsController < ApplicationController
  before_action :authenticate_user!
  before_action :set_movie, only: [:index, :create]

  def index
    if params[:step] == '2'
      @shows = @movie.shows.where(date: params[:date].to_date)
      @screens = Theatre.last.screens.order('price ASC').includes(:rows => :seats)
      get_available_seats
    else
      @shows = @movie.shows.group_by{|e|e.date}
    end
    respond_to do |format|
      format.html
      format.js
    end
  end
  
  def get_available_seats
    booking_date = params[:date].to_date
    time_slot_id = params[:ts_id]
    show = @movie.shows.where(time_slot_id: params[:ts_id], date: params[:date].to_date).last
    @bookings = Booking.where(movie_id: @movie.id, booking_for_date: booking_date, show_id: show.id).includes(:movie, :booked_seats)
    @booked_seats = []
    if @bookings.present?
      @bookings.each do |booking|
        booking.booked_seats.each do |seat|
          @booked_seats << seat.seat_id
        end
      end
    end
  end

  def new

  end

  def create
    if check_valid_booking
      show = @movie.shows.where(time_slot_id: params[:time_slot_id], date: params[:booking_for_date].to_date).last
      @booking = Booking.create(
                      movie_id: @movie.id,
                      show_id: show.id,
                      booking_for_date: params[:booking_for_date].to_date,
                      customer_id: current_user.id,
                    )
      params[:seat_numbers].split(',').each do |seat_id|
        @booking.booked_seats.create(seat_id: seat_id)
      end
    else
      @cant_book = true
      @err_msg = "Sorry can't book, some of the seats just got booked. Please choose other seats."
    end  
    respond_to do |format|
      format.js
    end
  end

  def show
    @booking = Booking.find(params[:id])
    @movie = @booking.movie
  end

  def check_valid_booking
    true
  end

  def edit

  end

  def update

  end

  def destroy

  end

  def donwload_invoice
    @booking = Booking.find(params[:id])
    @movie = @booking.movie
    respond_to do |format|
      format.html
      format.pdf do
       render pdf: "#{@movie.name.downcase}-invoice",
       template: "bookings/invoice.pdf.erb",
       :disposition => 'attachment',
       layout: nil
     end
    end
  end

  private

  def set_movie
    @movie = Movie.find(params[:id])
  end

end

app/controllers/home_controller.rb
class HomeController < ApplicationController
	def index
		@movies = Movie.all		
	end
end

app/controllers/users/unlocks_controller.rb
# frozen_string_literal: true

class Users::UnlocksController < Devise::UnlocksController
  # GET /resource/unlock/new
  # def new
  #   super
  # end

  # POST /resource/unlock
  # def create
  #   super
  # end

  # GET /resource/unlock?unlock_token=abcdef
  # def show
  #   super
  # end

  # protected

  # The path used after sending unlock password instructions
  # def after_sending_unlock_instructions_path_for(resource)
  #   super(resource)
  # end

  # The path used after unlocking the resource
  # def after_unlock_path_for(resource)
  #   super(resource)
  # end
end

app/helpers/admin/bookings_helper.rb
module Admin::BookingsHelper
end

app/helpers/application_helper.rb
module ApplicationHelper
	def get_qr_code
    require 'rqrcode'
    qrcode = RQRCode::QRCode.new("http://github.com/")
    png = qrcode.as_png(
      color_mode: ChunkyPNG::COLOR_GRAYSCALE,
      color: 'black',
      size: 325    
    )
  end
end

app/helpers/bookings_helper.rb
module BookingsHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
  <head>
    <title>Book My Show</title>
    <%= action_cable_meta_tag %>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="">
    <meta name="author" content="">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.11.0/umd/popper.min.js" integrity="sha384-b/U6ypiBEHpOf/4+1nzFpr53nxSS+GLCkfwBdFNTxtclqqenISfwAzpKaMNFNmj4" crossorigin="anonymous"></script>

    <%= stylesheet_link_tag    'application', media: 'all'%>
    <%= javascript_include_tag 'application' %>
  </head>
  <body class="skin-default fixed-layout">
      <!-- Preloader -->
    <div class="preloader">
        <div class="cssload-speeding-wheel"></div>
    </div>
    <div id="wrapper">
        <!-- Navigation -->
        <%= render :partial=> "shared/topbar"%>
        <% if current_user.present? %>
          <%= render :partial=> "shared/leftbar" %>
        <% end %>

        <!-- Page Content -->
        <div id="page-wrapper" class="<%= current_user.present? ? '' : 'no-margin'%>">
          <div class="container">
            <%= yield %>
          </div>
            
          <!-- /.container-fluid -->
        </div>
        
        <!-- /#page-wrapper -->
        <div class="loader-full-page hide">
          <h3 class="text-white"><i class="fa fa-spinner fa-spin"></i>&nbsp;Loading</h3>
        </div>
    </div>
    
    <script src="//cdn.datatables.net/plug-ins/1.10.16/filtering/row-based/range_dates.js"></script>
   
  </body>
</html>

app/views/layouts/devise.html.erb
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
  <head>
    <meta content="text/html; charset=UTF-8" http-equiv="Content-Type"/>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="">
    <meta name="author" content="">
    <title>Movies Junction</title>
    <%= csrf_meta_tags %>
    <%= stylesheet_link_tag    'application', media: 'all'%>
    <%= javascript_include_tag 'application' %>
  </head>
  <body>
      <!-- Preloader -->
    <div class="preloader">
        <div class="cssload-speeding-wheel"></div>
    </div>
    <div id="wrapper" style="height: 100vh;overflow-y: auto;">
        <!-- Page Content -->
          <%= yield %>
    </div>
  </body>
</html>

app/views/shared/_admin_menu.html.erb
<li><a href="<%= root_path %>"><i class=" fa fa-home"></i> Home</a></li>
<li><a href="<%= admin_bookings_path %>"><i class=" fa fa-home"></i> All Bookings</a></li>
<li><a href="<%= admin_reports_url %>"><i class=" fa fa-home"></i> Reports </a></li>
<li><a href="<%= destroy_user_session_path %>" data-method="delete" class="waves-effect"><i class="icon-logout fa-fw"></i> <span class="hide-menu">Log out</span></a></li>

app/views/shared/_flash_messages.html.erb
<div class="custom-alerts row">
    <% flash.each do |key, value| %>
        <div class="<%= flash_class(key)%> fade in alert-dismissable full-width" >
            <a href="#" class="close" data-dismiss="alert" style="opacity: 1"><%= raw(value)%></a>
        </div>
    <% end %>
</div>

<script>
$(function(){
    setTimeout(function(){
        $(".custom-alerts .alert").not(".alert-danger").addClass("hide")
    },6000)
});
</script>

app/views/shared/_leftbar.html.erb
<!-- Left navbar-header -->
<div class="navbar-default sidebar" role="navigation">
    <div class="sidebar-nav navbar-collapse slimscrollsidebar">
        <% if user_signed_in?%>
            <div class="user-profile">
                <div class="dropdown user-pro-body">
                    <div><img src="/assets/users/default_user.png" alt="user-img" class="img-circle"></div>
                    <a href="#" class="dropdown-toggle u-dropdown" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false"><%= current_user.email rescue '' %><span class="caret"></span></a>
                    <ul class="dropdown-menu animated flipInY">
                        <li><a href=""><i class="ti-user"></i> My Profile</a></li>
                        <li role="separator" class="divider"></li>
                        <li><a href="<%= destroy_user_session_path %>" data-method="delete" ><i class="fa fa-power-off"></i> Logout</a></li>
                    </ul>
                </div>
            </div>
        <% end %>
        <ul class="nav" id="side-menu">
            
            <% if !user_signed_in?%>

            <% elsif current_user.admin? %>
                <%= render :partial=> "shared/admin_menu"%>
            <% else %>
                <%= render :partial=> "shared/user_menu"%>
            <% end %>

        </ul>
    </div>
</div>
<!-- Left navbar-header end -->

app/views/shared/_topbar.html.erb
<nav class="navbar navbar-default navbar-static-top m-b-0">
  <div class="navbar-header"> <a class="navbar-toggle hidden-sm hidden-md hidden-lg " href="javascript:void(0)" data-toggle="collapse" data-target=".navbar-collapse"><i class="ti-menu"></i></a>
      <div class="top-left-part hidden-xs">
          <a class="logo" href="/" style="text-align: center;display: flex;justify-content: center;">
              <img src="/assets/sofu_new.png" alt="home" class="light-logo" style="width: 80%; margin: 10px; height: 50px;"/>
          </a>
      </div>
     
      <ul class="nav navbar-top-links navbar-right pull-right hidden-sm hidden-md hidden-lg " style="width: 85%; padding: 10px">
          <li class="dropdown"> 
              <a class="dropdown-toggle waves-effect waves-light" data-toggle="dropdown" href="#"  >
                 <img src="/assets/sofu_new.png" alt="home" class="light-logo" style="width: 100%; height: 60px; height: 50px;"/>
              </a>
          </li>
               
      </ul> 
      <% if user_signed_in? %>
        <span class="welcome-msg">Welcome, <%= current_user.email %></span>
        <a href="<%= destroy_user_session_path %>" data-method="delete" class="pull-right session-btn waves-effect"><i class="icon-logout fa-fw"></i> <span class="hide-menu">Log out</span></a>
      <% else %>
        <a href="<%= new_user_session_path %>" class="session-btn pull-right waves-effect"><i class="icon-login fa-fw"></i> <span class="hide-menu">Log In</span></a>
      <% end %>
  </div>
 
  <%#= link_to "Sign In", new_user_session_path, :class => 'nav-link btn btn-primary btn-sm' %>  

  <!-- /.navbar-header -->
  <!-- /.navbar-top-links -->
  <!-- /.navbar-static-side -->
</nav>

app/views/shared/_user_menu.html.erb
<li><a href="<%= root_path %>"><i class=" fa fa-home"></i> Home</a></li>
<!-- <li><a href="<%#= profile_path(current_user.profile.id, :tab=>"profile")%>"><i class="ti-user"></i> My Profile</a></li>
<li><a href="<%#= profile_path(current_user.profile.id, :tab=>"parcels")%>"><i class="fa  fa-cube"></i> My Parcels</a></li>
<li><a href="<%#= profile_path(current_user.profile.id, :tab=>"invoices")%>"><i class="fa fa-copy"></i> My Shipping Invoices</a></li>
<li><a href="<%#= profile_path(current_user.profile.id, :tab=>"duty_invoices")%>"><i class="fa fa-copy"></i> My Duty Invoices</a></li>
<li><a href="<%#= profile_path(current_user.profile.id, :tab=>"virtual_addresses")%>"><i class="fa   fa-th-large"></i> My Virtual Address </a></li>
<li><a href="<%#= profile_path(current_user.profile.id, :tab=>"conceirge")%>"><i class=" fa fa-shopping-basket"></i> My Concierge </a></li>
<li><a href="<%#= calculate_path %>"><i class=" fa fa-calculator"></i> Rate Calculator</a></li> -->

<li><a href="<%= destroy_user_session_path %>" data-method="delete" class="waves-effect"><i class="icon-logout fa-fw"></i> <span class="hide-menu">Log out</span></a></li>